/*	
 *	clipdmc.h
 *
 *	P/ECE DMG-CPU (Sharp LR35902) Emulator ()
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2005 Naoyuki Sawa
 *
 *	* Sun Feb 13 03:10:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_DMC_H__
#define __CLIP_DMC_H__

/****************************************************************************
 *
 ****************************************************************************/

/* spDMG-CPU\̂łB */
typedef struct _DMGCPU {
	unsigned short cz;		/* + 0,2: -------C zzzzzzzz (C=F(C),z=!F(Z)) */
	unsigned char  nh;		/* + 2,1:          --NH---- (N=F(N),H= F(H)) */
	unsigned char   a;		/* + 3,1: A        */
	unsigned short bc;		/* + 4,2: BC       */
	unsigned short de;		/* + 6,2: DE       */
	unsigned short hl;		/* + 8,2: HL       */
	unsigned short sp;		/* +10,2: SP       */
	const unsigned char* pc;	/* +12,4: &mem[PC] */
	//
	unsigned char flags;		/* +16,1: -----SHI (S=STOP,H=HALT,I=IME) */
	//				/* +17,3: (pfBO) */
	int cycle;			/* +20,4: csTCN */
	void* read;			/* +24,4: ǂݏo[` */
	void* write;			/* +28,4: ݃[` */
} DMGCPU;				/* =32 */

/* DMGCPU.flags */
#define DMGCPU_IME				(1<<0)
#define DMGCPU_HALT				(1<<1)
#define DMGCPU_STOP				(1<<2)

/* $FF0F(IF)A$FFFF(IE) */
#define DMGCPU_V_BLANK				(1<<0)	/* RST $40 */
#define DMGCPU_LCDC_STATUS			(1<<1)	/* RST $48 */
#define DMGCPU_TIMER_OVERFLOW			(1<<2)	/* RST $50 */
#define DMGCPU_SERIAL_TRANSFER_COMPLETION	(1<<3)	/* RST $58 */
#define DMGCPU_HIGH_TO_LOW_OF_P10_P13		(1<<4)	/* RST $60 */

/* WX^ݒEQƗp̍\̂łB */
typedef struct _DMGREG {
	unsigned short af;		/* + 0,2 */
	unsigned short bc;		/* + 2,2 */
	unsigned short de;		/* + 4,2 */
	unsigned short hl;		/* + 6,2 */
	unsigned short sp;		/* + 8,2 */
	unsigned short pc;		/* +10,2 */
} DMGREG;				/* =12 */

extern DMGCPU dmgcpu;			/* RAMɔzu */
extern unsigned char dmgmem[0x10000];	/*    SRAMɔzu */

/****************************************************************************
 *	֐
 ****************************************************************************/

int/*%data*/ dmgmem_read(/*%addr*/);	/* Pȃǂݏo[` */
void  dmgmem_write(/*%addr,%data*/);	/* Pȃ݃[` */

/****************************************************************************
 *
 ****************************************************************************/

void dmgcpu_reset(void* read, void* write, int gb_ipl);
void dmgcpu_run(int cycle);
void dmgcpu_check_pending();
void dmgreg_put(const DMGREG* reg);
void dmgreg_get(DMGREG* reg);

#endif /*__CLIP_DMC_H__*/
